#pragma once
#include <stdlib.h>
#include <stdio.h>

static int * generate_vector(size_t N) {
  int *x = (int *) malloc(sizeof(int) * N);
  
  if(!x) {
    fprintf(stderr, "ERROR: Unable to allocate memory for vector\n");
    exit(1);
  }
  
  for(int i = 0; i < N; i++) {
    x[i] = (1.0 * random() / RAND_MAX) * (1 << 30) ; // may truncate
  }

  return x;
}


static int check_addition(size_t N, int *vec1, int *vec2, int *result) {
  for(int i = 0; i < N; i++) {
    // print out small results
    if(N < 32) {
      printf("%d: %d + %d = %d\n", i, vec1[i], vec2[i], result[i]);
    }

    if(vec1[i] + vec2[i] != result[i]) {
      fprintf(stderr, "ERROR: Incorrect result (%d + %d = %d, but should be %d) at index %d\n", vec1[i], vec2[i], result[i], vec1[i] + vec2[i], i);
      exit(1);
    }
  }

  return 1;
}
